<?php

namespace Teknisa\FIN\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Fiscal\Entities\Notafiscal;

class ImportacaoTitulosFactory {
    
    protected $entityManager;
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    public function getFilialDeOrigem($cdempresa, $cdfilial, $nrorg){
        $params = array();
        $params['P_CDEMPRESA'] = $cdempresa;
        $params['P_CDFILIAL'] = $cdfilial;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDFILIAL, NMFILIAL, CDINSCESTA, CDINSCMUNI, NRORG FROM(SELECT FI.CDFILIAL, FI.NMFILIAL, FI.CDEMPRESA, FI.CDINSCESTA, FI.CDINSCMUNI, NVL(PF.NRTAMNUMNFUTDFE,0) AS NRTAMNUMNFUTDFE, FI.CDCENTCUST, PF.NRORG AS NRORG FROM PARAMFILIAL PF, FILIAL FI WHERE(FI.CDEMPRESA = :P_CDEMPRESA) AND (FI.CDFILIAL = :P_CDFILIAL) AND (FI.IDCNTRRESC = 'N') AND (PF.CDFILIAL = FI.CDFILIAL) AND (PF.NRORG = FI.NRORG) UNION SELECT EF.CDFILIAL, FI.NMFILIAL, EF.CDEMPRESA, EF.CDINSCESTA, EF.CDINSCMUNI, NVL(PF.NRTAMNUMNFUTDFE,0) AS NRTAMNUMNFUTDFE, FI.CDCENTCUST, PF.NRORG AS NRORG FROM PARAMFILIAL PF, FILIAL FI, EMPRCNTRFIL EF WHERE (EF.CDEMPRESA = :P_CDEMPRESA) AND (FI.CDFILIAL = :P_CDFILIAL) AND (FI.IDCNTRRESC = 'N') AND (FI.CDFILIAL = EF.CDFILIAL) AND (PF.CDFILIAL = FI.CDFILIAL) AND (FI.NRORG = EF.NRORG)) A WHERE A.NRORG = :P_NRORG ORDER BY CDFILIAL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getCNPJOrCPFPagar($nrinsjurforn, $nrorg){
        $params = array();
        $params['P_NRINSJURFORN'] = $nrinsjurforn;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDFORNECED, IDTPIJURFORN, NRINSJURFORN, NMRAZSOCFORN FROM FORNECEDOR WHERE NRINSJURFORN = :P_NRINSJURFORN AND NRORG = :P_NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getCNPJOrCPFReceber($nrinsjurclie, $nrorg){
        $params = array();
        $params['P_NRINSJURCLIE'] = $nrinsjurclie;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDCLIENTE, IDTPIJURCLIE, NRINSJURCLIE, NMRAZSOCCLIE FROM CLIENTE WHERE NRINSJURCLIE = :P_NRINSJURCLIE AND NRORG = :P_NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getTipoDeOperacaoPagar($cdtipooper, $nrorg){
        $params = array();
        $params['P_CDTIPOOPER'] = $cdtipooper;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDTIPOOPER, NMTIPOOPER FROM TIPOOPERAC WHERE IDENTRSAIDOP = 'E' AND CDTIPOOPER = :P_CDTIPOOPER AND NRORG = :P_NRORG ORDER BY CDTIPOOPER";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getTipoDeOperacaoReceber($cdtipooper, $nrorg){
        $params = array();
        $params['P_CDTIPOOPER'] = $cdtipooper;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDTIPOOPER, NMTIPOOPER FROM TIPOOPERAC WHERE IDENTRSAIDOP = 'S' AND CDTIPOOPER = :P_CDTIPOOPER AND NRORG = :P_NRORG ORDER BY CDTIPOOPER";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getTipoDeContaPagar($cdtpctpagar, $nrorg){
        $params = array();
        $params['P_CDTPCTPAGAR'] = $cdtpctpagar;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDTPCTPAGAR, DSTPCTPAGAR, IDCTBLCTPAG, DSDEFACTPAG, CDCLASSFINA, IDUTLANCCPAG FROM TIPOCTPAGAR WHERE CDTPCTPAGAR = :P_CDTPCTPAGAR AND NRORG = :P_NRORG ORDER BY CDTPCTPAGAR";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getTipoDeContaReceber($cdtpctreceb, $nrorg){
        $params = array();
        $params['P_CDTPCTRECEB'] = $cdtpctreceb;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDTPCTRECEB, DSTPCTRECEB, IDCTBLCTREC, DSDEFACTREC, CDCLASSFINA, IDUTLANCCREC FROM TIPOCTRECEBER WHERE CDTPCTRECEB= :P_CDTPCTRECEB AND NRORG = :P_NRORG ORDER BY CDTPCTRECEB";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getSerieDaNotaPagar($cdserieentr, $nrorg){
        $params = array();
        $params['P_CDSERIEENTR'] = $cdserieentr;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDSERIEENTR, DSSERIEENTR FROM SERIEENTR WHERE CDSERIEENTR = :P_CDSERIEENTR AND NRORG = :P_NRORG ORDER BY CDSERIEENTR";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getSerieDaNotaReceber($cdserie, $nrorg){
        $params = array();
        $params['P_CDSERIE'] = $cdserie;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDEMPRESA, CDINSCESTA, CDINSCMUNI, CDSERIE FROM SERIENF WHERE CDSERIE = :P_CDSERIE AND NRORG = :P_NRORG ORDER BY CDSERIE";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getCodReduzidoContaCorrente($cdempresa, $cdreducont, $nrorg){
        $params = array();
        $params['P_CDEMPRESA'] = $cdempresa;
        $params['P_CDREDUCONT'] = $cdreducont;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDREDUCONT  FROM CONTCORR WHERE CDEMPRESA = NVL(:P_CDEMPRESA, CDEMPRESA) AND CDREDUCONT = :P_CDREDUCONT AND NRORG = :P_NRORG"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getTipoDeBaixa($cdtpbaixarec, $nrorg){
        $params = array();
        $params['P_CDTPBAIXAREC'] = $cdtpbaixarec;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT CDTPBAIXAREC FROM TIPOBAIXAREC where CDTPBAIXAREC = :P_CDTPBAIXAREC AND NRORG = :P_NRORG ORDER BY CDTPBAIXAREC"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getNotaFicalPagar($cdfilirece, $nrnotafisc, $cdserieentr, $nrinsjurnf, $vrnotafisc, $nrorg){
        $params = array();
        $params['nrorg'] = $nrorg;
        $params['cdfilirece'] = $cdfilirece;
        $params['nrnotafisc'] = $nrnotafisc;
        $params['cdserieentr'] = $cdserieentr;
        $params['nrinsjurnf'] = $nrinsjurnf;
        $params['vrnotafisc'] = $vrnotafisc;
        $params['idsistema'] = 'PAG';
        $params['identrsaidop'] = 'E';
        $notafiscal = $this->entityManager->getRepository(Notafiscal::class)->findOneBy($params);
        return $notafiscal;
    }
    
    public function getNotaFicalReceber($cdfiliemit, $nrnotafisc, $cdserie, $nrinsjurnf, $vrnotafisc, $nrorg){
        $params = array();
        $params['nrorg'] = $nrorg;
        $params['cdfiliemit'] = $cdfiliemit;
        $params['nrnotafisc'] = $nrnotafisc;
        $params['cdserie'] = $cdserie;
        $params['nrinsjurnf'] = $nrinsjurnf;
        $params['vrnotafisc'] = $vrnotafisc;
        $params['idsistema'] = 'REC';
        $params['identrsaidop'] = 'S';
        $notafiscal = $this->entityManager->getRepository(Notafiscal::class)->findOneBy($params);
        return $notafiscal;
    }
    
    /**
     * Busca Centro de Custo Filial
     * @param $cdfilial
     * @param $cdempresa
     * @return array
     */
    public function buscaCentCustFili($cdfilial, $cdempresa, $nrorg){

        /** @var $params */
        $params = array();
        $params['P_CDFILIAL' ] = $cdfilial;
        $params['P_CDEMPRESA'] = $cdempresa;
        $params['P_NRORG'] = $nrorg;

        $sql = "SELECT F.CDFILIAL, NVL(F.CDCENTCUST, E.CDCENTCUST) AS CDCENTCUST
                  FROM FILIAL F, EMPRESA E
                 WHERE F.CDFILIAL   = :P_CDFILIAL  AND
                       E.CDEMPRESA  = :P_CDEMPRESA AND
                       (F.CDEMPRESA = E.CDEMPRESA) AND
                       E.NRORG = :P_NRORG AND
                       E.NRORG = F.NRORG
                 UNION
                SELECT F.CDFILIAL, NVL(F.CDCENTCUST, E.CDCENTCUST) AS CDCENTCUST
                  FROM FILIAL F, EMPRESA E, EMPRCNTRFIL EC
                 WHERE EC.CDFILIAL  = :P_CDFILIAL  AND
                       EC.CDEMPRESA = :P_CDEMPRESA AND
                       E.CDEMPRESA  = EC.CDEMPRESA AND
                       (F.CDFILIAL  = EC.CDFILIAL) AND
                       E.NRORG = :P_NRORG AND
                       E.NRORG = F.NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getNumeroNotaFiscalLength($cdfilial, $nrorg){
        $params = array();
        $params['P_CDFILIAL'] = $cdfilial;
        $params['P_NRORG'] = $nrorg;
        $sql = "SELECT NVL(PF.NRTAMNUMNFUTDFE, 10) AS NRTAMENTRADA, NVL(PF.NRTAMNUMNFUT, 7) AS NRTAMSAIDA FROM FILIAL F, PARAMFILIAL PF WHERE F.CDFILIAL = PF.CDFILIAL AND F.CDFILIAL = :P_CDFILIAL AND F.NRORG = :P_NRORG AND F.NRORG = PF.NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
}