<?php
/**
 * Created by PhpStorm.
 * User: leonardooliveira
 * Date: 08/09/14
 * Time: 15:49
 */

namespace Financeiro\Logic\ControleBancario\ConciliacaoBancaria;

use Financeiro\Entities\Movreal;
use Financeiro\Entities\Movbancario;
use Financeiro\Entities\Concimovbanc;
use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;
class ConciliacaoManual {

    const IDCONCILIADO = '1';
    const IDCONCREAL = 'M';

    public static function geraConcilialcao($nrorg, $cdreducont){
        try {
            $nrConciliacao = NovoCodigo::geraCodigo($nrorg, 'CONCIMOVBANC' . $cdreducont);

            $conciliacao = New Concimovbanc();
            $conciliacao->setNrorg($nrorg);
            $conciliacao->setCdreducont($cdreducont);
            $conciliacao->setNrconcimovb($nrConciliacao);
            $conciliacao->setDtinclusao(DateUtil::getDataAtual());
            $conciliacao->persist();

            Registry::getEntityManager()->flush();

            return $nrConciliacao;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function updateMovreal($nrorg, $cdreducont, $cdsequextr, $nrseqmovreal, $nrConciliacao){
        try {
            /** @var $movreal Movreal */
            $movreal = Movreal::findOneByNrorgAndCdreducontAndCdsequextrAndNrseqmovreal(
                $nrorg, $cdreducont, $cdsequextr, $nrseqmovreal
            );
            $movreal->setNrconcimovb($nrConciliacao);
            $movreal->setIdstconmvban(self::IDCONCILIADO);
            $movreal->setIdconcreal(self::IDCONCREAL);
            $movreal->persist();

            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function updateMovbanc($nrorg, $cdreducont, $nrmovbanc, $nrConciliacao){
        try {
            /** @var $movbanc Movbancario */
            $movbanc = Movbancario::findOneByNrorgAndCdreducontAndNrmovbanc($nrorg, $cdreducont, $nrmovbanc);
            $movbanc->setNrconcimovb($nrConciliacao);
            $movbanc->setIdstconext(self::IDCONCILIADO);
            $movbanc->setIdconcbanc(self::IDCONCREAL);
            $movbanc->persist();

            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function desconciliarMovimentos($nrorg, $cdreducont, $nrmovbanc, $nrconcimovb){
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();
        try {
            /** @var $movbanc Movbancario */
            /** @var $movreal Movreal */
            if ($nrconcimovb) {
                $movbanc = Movbancario::findByNrorgAndCdreducontAndNrconcimovb($nrorg, $cdreducont, $nrconcimovb);
                $movreal = Movreal::findByNrorgAndCdreducontAndNrconcimovb($nrorg, $cdreducont, $nrconcimovb);
            } else {
                $movbanc = Movbancario::findByNrorgAndCdreducontAndNrmovbancAndIdstconext($nrorg, $cdreducont, $nrmovbanc, self::IDCONCILIADO);
                $movreal = Movreal::findByNrorgAndCdreducontAndNrmovbareAndIdstconmvban($nrorg, $cdreducont, $nrmovbanc, self::IDCONCILIADO);
            }

            /** @var $movimento Movbancario */
            foreach ($movbanc as $movimento) {
                $movimento->setIdstconext(0);
                $movimento->setIdconcbanc(NULL);
                $movimento->setCdsequexba(NULL);
                $movimento->setNrseqmovreba(NULL);
                $movimento->setNrconcimovb(NULL);
                $movimento->persist();
            }

            /** @var $extrato Movreal */
            foreach($movreal as $extrato){
                $extrato->setIdstconmvban(0);
                $extrato->setIdconcreal(NULL);
                $extrato->setNrmovbare(NULL);
                $extrato->setNrconcimovb(NULL);
                $extrato->persist();
            }
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            throw $e;
        }

    }
} 